Index: /code/branches/environment2/src/orxonox/OrxonoxPrereqs.h
===================================================================
--- /code/branches/environment2/src/orxonox/OrxonoxPrereqs.h	(revision 8434)
+++ /code/branches/environment2/src/orxonox/OrxonoxPrereqs.h	(revision 8435)
@@ -111,4 +111,5 @@
     class FadingBillboard;
     class GlobalShader;
+    class GlobalGodrayShader;
     class Light;
     class Model;
Index: /code/branches/environment2/src/orxonox/graphics/CMakeLists.txt
===================================================================
--- /code/branches/environment2/src/orxonox/graphics/CMakeLists.txt	(revision 8434)
+++ /code/branches/environment2/src/orxonox/graphics/CMakeLists.txt	(revision 8435)
@@ -4,4 +4,5 @@
   FadingBillboard.cc
   GlobalShader.cc
+  GlobalGodrayShader.cc
   MeshLodInformation.cc
   Model.cc
Index: /code/branches/environment2/src/orxonox/graphics/GlobalGodrayShader.cc
===================================================================
--- /code/branches/environment2/src/orxonox/graphics/GlobalGodrayShader.cc	(revision 8435)
+++ /code/branches/environment2/src/orxonox/graphics/GlobalGodrayShader.cc	(revision 8435)
@@ -0,0 +1,68 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Markus 'atok' Wegmann
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+ @file
+ 
+ @brief Implementation of the GlobalGodrayShader.
+ */
+
+#include "GlobalShader.h"
+
+#include "util/Exception.h"
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+
+namespace orxonox
+{
+    CreateFactory(GlobalGodrayShader);
+    
+    GlobalGodrayShader::GlobalGodrayShader(BaseObject* creator, WorldEntity blurObject) : BaseObject(creator)
+    {
+        RegisterObject(GlobalGodrayShader);
+        
+        if (!this->getScene())
+            ThrowException(AbortLoading, "Can't create GlobalGodrayShader, no scene given.");
+        //        if (!this->getScene()->getSceneManager())
+        //            ThrowException(AbortLoading, "Can't create GlobalGodrayShader, no scene manager given.");
+        
+        if (this->getScene()->getSceneManager())
+            this- setSceneManager(this->getScene()->getSceneManager());
+    }
+    
+    GlobalGodrayShader::~GlobalShader()
+    {
+    }
+    
+    void GlobalGodrayShader::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(GlobalGodrayShader, XMLPort, xmlelement, mode);
+        
+        XMLPortParamExtern(GlobalShader, Shader, &this->shader_, "compositor", setCompositorName, getCompositorName, xmlelement, mode);
+    }
+}
Index: /code/branches/environment2/src/orxonox/graphics/GlobalGodrayShader.h
===================================================================
--- /code/branches/environment2/src/orxonox/graphics/GlobalGodrayShader.h	(revision 8435)
+++ /code/branches/environment2/src/orxonox/graphics/GlobalGodrayShader.h	(revision 8435)
@@ -0,0 +1,74 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Markus 'atok' Wegmann
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+/**
+ @file
+ 
+ @brief Header of the GlobalGodrayShader.
+*/
+
+
+#ifndef _GlobalGodrayShader_H__
+#define _GlobalGodrayShader_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "tools/interfaces/Tickable.h"
+#include "core/BaseObject.h"
+#include "GlobalShader.h"
+
+
+namespace orxonox
+{
+    /**
+     @brief 
+     
+    */
+    class _OrxonoxExport GlobalGodrayShader : public BaseObject, public Tickable
+    {
+    public:
+        GlobalGodrayShader(BaseObject* creator);
+        virtual ~GlobalGodrayShader();
+        
+        virtual void tick(float dt);
+        
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+        
+        inline const GlobalShader& getGlobalShader() const
+        { return this->globalShader_; }
+        
+    private:
+        
+        GlobalShader globalShader_;
+        Vector3 
+        
+    };
+}
+
+#endif /* _GlobalGodrayShader_H__ */