Index: /branches/gui/src/lib/gui/gl/glgui_defs.h
===================================================================
--- /branches/gui/src/lib/gui/gl/glgui_defs.h	(revision 8445)
+++ /branches/gui/src/lib/gui/gl/glgui_defs.h	(revision 8446)
@@ -22,5 +22,5 @@
   } Orientation;
 
-  const std::string OrientationString[2] = {
+  const std::string OrientationString[] = {
     "Horizontal",
     "Vertical"
@@ -36,4 +36,5 @@
   //! The count of States a GUI-Element can be in.
 #define GLGUI_STATE_COUNT   4
+#define GLGUI_DEFAULT_STYLE OrxGui::Normal
 
   const std::string StateString[] =
@@ -45,4 +46,19 @@
     };
 
+    //! Where a Certain feature will be positioned at.
+    typedef enum {
+      FeatureLeft,          //!< On the Left side.
+      FeatureRight,         //!< On the Right side.
+      FeatureTop,           //!< On Top of the rest of the Widget.
+      FeatureBottom,        //!< At the Bottom of the rest of the Widget.
+    } FeaturePosition;
+
+    const std::string FeaturePositionString[] =
+    {
+      "Left",
+      "Right",
+      "Top",
+      "Bottom"
+    };
 
 
Index: /branches/gui/src/lib/gui/gl/glgui_style.cc
===================================================================
--- /branches/gui/src/lib/gui/gl/glgui_style.cc	(revision 8445)
+++ /branches/gui/src/lib/gui/gl/glgui_style.cc	(revision 8446)
@@ -18,4 +18,6 @@
 #include "glgui_style.h"
 
+#include "loading/load_param.h"
+
 namespace OrxGui
 {
@@ -25,6 +27,10 @@
    * @brief standard constructor
   */
-  GLGuiStyle::GLGuiStyle ()
+  GLGuiStyle::GLGuiStyle (const TiXmlElement* root)
   {
+    if (root != NULL)
+      this->loadParams(root);
+
+    this->
   }
 
@@ -37,3 +43,145 @@
     // delete what has to be deleted here
   }
+
+  void GLGuiStyle::loadParams(const TiXmlElement* root)
+  {
+  }
+
+  void GLGuiStyle::setBorderLeft(float value)
+  {
+    for (unsigned int i = 0; i < GLGUI_STATE_COUNT; ++i)
+      setBorderLeft(value, (OrxGui::State)i);
+  }
+
+  void GLGuiStyle::setBorderLeft(float value, OrxGui::State state)
+{}
+
+  void GLGuiStyle::setBorderLeftS(float value, const std::string& state)
+  {}
+
+
+  void GLGuiStyle::setBorderRight(float value)
+  {
+    for (unsigned int i = 0; i < GLGUI_STATE_COUNT; ++i)
+      setBorderRight(value, (OrxGui::State)i);
+  }
+
+  void GLGuiStyle::setBorderRight(float value, OrxGui::State state)
+{}
+
+  void GLGuiStyle::setBorderRightS(float value, const std::string& state)
+  {}
+
+
+  void GLGuiStyle::setBorderTop(float value)
+  {
+    for (unsigned int i = 0; i < GLGUI_STATE_COUNT; ++i)
+      setBorderTop(value, (OrxGui::State)i);
+  }
+
+  void GLGuiStyle::setBorderTop(float value, OrxGui::State state)
+{}
+
+  void GLGuiStyle::setBorderTopS(float value, const std::string& state)
+  {}
+
+
+  void GLGuiStyle::setBorderBottom(float value)
+  {
+    for (unsigned int i = 0; i < GLGUI_STATE_COUNT; ++i)
+      setBorderBottom(value, (OrxGui::State)i);
+  }
+
+  void GLGuiStyle::setBorderBottom(float value, OrxGui::State state)
+{}
+
+  void GLGuiStyle::setBorderBottomS(float value, const std::string& state)
+  {}
+
+
+  void GLGuiStyle::setTextSize(float value)
+  {
+    for (unsigned int i = 0; i < GLGUI_STATE_COUNT; ++i)
+      setTextSize(value, (OrxGui::State)i);
+  }
+
+  void GLGuiStyle::setTextSize(float value, OrxGui::State state)
+{}
+
+  void GLGuiStyle::setTextSizeS(float value, const std::string& state)
+  {}
+
+
+  void GLGuiStyle::setBackgroundColor(const Color& color)
+  {
+    for (unsigned int i = 0; i < GLGUI_STATE_COUNT; ++i)
+      setBackgroundColor(color, (OrxGui::State)i);
+  }
+
+  void GLGuiStyle::setBackgroundColor(const Color& color, OrxGui::State state)
+{}
+
+  void GLGuiStyle::setBackgroundColorS(float r, float g, float b, float a, const std::string& state)
+  {}
+
+
+  void GLGuiStyle::setBackgroundTexture(const Texture& texture)
+  {
+    for (unsigned int i = 0; i < GLGUI_STATE_COUNT; ++i)
+      setBackgroundTexture(texture, (OrxGui::State)i);
+  }
+
+  void GLGuiStyle::setBackgroundTexture(const Texture& texture, OrxGui::State state)
+{}
+
+  void GLGuiStyle::setBackgroundTexture(const std::string& textureName, const std::string& state)
+  {}
+
+
+  void GLGuiStyle::setForegroundColor(const Color& color)
+  {
+    for (unsigned int i = 0; i < GLGUI_STATE_COUNT; ++i)
+      setForegroundColor(color, (OrxGui::State)i);
+  }
+
+  void GLGuiStyle::setForegroundColor(const Color& color, OrxGui::State state)
+  {}
+
+  void GLGuiStyle::setForegroundColorS(float r, float g, float b, float a, const std::string& state)
+  {}
+
+
+
+  void GLGuiStyle::setFeaturePosition(FeaturePosition featurePosition)
+  {
+    this->_featurePosition = featurePosition;
+  }
+
+  void GLGuiStyle::setFeaturePosition(const std::string& featurePosition)
+  {
+
+  }
+
+
+  void GLGuiStyle::setFont(Font* font)
+  {
+    this->_font = font;
+  }
+
+  void GLGuiStyle::setFont(const std::string& fontName)
+  {
+    //this->font = new Font(fontName);
+  }
+
+
+  void GLGuiStyle::setAnimated(bool animated)
+  {
+    this->_animated = animated;
+  }
+
+  void GLGuiStyle::animatedStateChanges(bool animated)
+  {
+    this->_animatedStateChanges = animated;
+  }
+
 }
Index: /branches/gui/src/lib/gui/gl/glgui_style.h
===================================================================
--- /branches/gui/src/lib/gui/gl/glgui_style.h	(revision 8445)
+++ /branches/gui/src/lib/gui/gl/glgui_style.h	(revision 8446)
@@ -13,4 +13,6 @@
 #include "color.h"
 
+class TiXmlElement;
+
 namespace OrxGui
 {
@@ -19,16 +21,69 @@
   {
   public:
+    GLGuiStyle(const TiXmlElement* root = NULL);
+    virtual ~GLGuiStyle();
 
-    //! Where a Certain feature will be positioned at.
-    typedef enum {
-      FeatureLeft,          //!< On the Left side.
-      FeatureRight,         //!< On the Right side.
-      FeatureTop,           //!< On Top of the rest of the Widget.
-      FeatureBottom,        //!< At the Bottom of the rest of the Widget.
-    } FeaturePosition;
 
-  public:
-    GLGuiStyle();
-    virtual ~GLGuiStyle();
+    /// Retrieve
+    inline float borderLeft(OrxGui::State state = GLGUI_DEFAULT_STYLE) const { return _style[state]._borderLeft; }
+    inline float borderRight(OrxGui::State state = GLGUI_DEFAULT_STYLE) const { return _style[state]._borderRight; }
+    inline float borderTop(OrxGui::State state = GLGUI_DEFAULT_STYLE) const { return _style[state]._borderTop; }
+    inline float borderBottom(OrxGui::State state = GLGUI_DEFAULT_STYLE) const { return _style[state]._borderBottom; }
+    inline float textSize(OrxGui::State state = GLGUI_DEFAULT_STYLE) const { return _style[state]._textSize; }
+    inline const Color& backgroundColor(OrxGui::State state= GLGUI_DEFAULT_STYLE) const { return _style[state]._backgroundColor; }
+    inline const Texture& backgrorundTexture(OrxGui::State state= GLGUI_DEFAULT_STYLE) const { return _style[state]._backgroundTexture; }
+    inline const Color& foregroundColor(OrxGui::State state= GLGUI_DEFAULT_STYLE) const { return _style[state]._foregroundColor; }
+
+    inline FeaturePosition featurePosition() const { return _featurePosition; }
+    inline const Font* const font() const { return _font; }
+    inline bool animated() const { return _animated; }
+    inline bool animatedStateChanges() const { return _animatedStateChanges; }
+
+
+
+    /// SETUP
+    void loadParams(const TiXmlElement* root);
+
+    void setBorderLeft(float value);
+    void setBorderLeft(float value, OrxGui::State state);
+    void setBorderLeftS(float value, const std::string& state);
+
+    void setBorderRight(float value);
+    void setBorderRight(float value, OrxGui::State state);
+    void setBorderRightS(float value, const std::string& state);
+
+    void setBorderTop(float value);
+    void setBorderTop(float value, OrxGui::State state);
+    void setBorderTopS(float value, const std::string& state);
+
+    void setBorderBottom(float value);
+    void setBorderBottom(float value, OrxGui::State state);
+    void setBorderBottomS(float value, const std::string& state);
+
+    void setTextSize(float value);
+    void setTextSize(float value, OrxGui::State state);
+    void setTextSizeS(float value, const std::string& state);
+
+    void setBackgroundColor(const Color& color);
+    void setBackgroundColor(const Color& color, OrxGui::State state);
+    void setBackgroundColorS(float r, float g, float b, float a, const std::string& state);
+
+    void setBackgroundTexture(const Texture& texture);
+    void setBackgroundTexture(const Texture& texture, OrxGui::State state);
+    void setBackgroundTexture(const std::string& textureName, const std::string& state);
+
+    void setForegroundColor(const Color& color);
+    void setForegroundColor(const Color& color, OrxGui::State state);
+    void setForegroundColorS(float r, float g, float b, float a, const std::string& state);
+
+
+    void setFeaturePosition(FeaturePosition featurePosition);
+    void setFeaturePosition(const std::string& featurePosition);
+
+    void setFont(Font* font);
+    void setFont(const std::string& fontName);
+
+    void setAnimated(bool animated);
+    void animatedStateChanges(bool animated);
 
   private:
@@ -43,5 +98,5 @@
 
       Color             _backgroundColor;      //!< The BackgroundColor of the Widget.
-      Texture           _backgorundTexture;    //!< The BackgroundTexture of the Widget.
+      Texture           _backgroundTexture;    //!< The BackgroundTexture of the Widget.
 
       Color             _foregroundColor;      //!< The foregroundColor of the Widget.
@@ -52,10 +107,10 @@
     StatedStyle         _style[GLGUI_STATE_COUNT];
 
-    FeaturePosition   _featurePosition;      //!< The Position a Feature will be layed at (checkbox(box), slider(text),...)
+    FeaturePosition     _featurePosition;      //!< The Position a Feature will be layed at (checkbox(box), slider(text),...)
     Font*               _font;                 //!< The Font used in the current Widget.
 
 
-    bool              _animated;             //!< If the Widget is animated (Texture might be an AnimatedTexture.)
-    bool              _animatedStateChanges; //!< If the Transitions between States are Animated automatically.
+    bool                _animated;             //!< If the Widget is animated (Texture might be an AnimatedTexture.)
+    bool                _animatedStateChanges; //!< If the Transitions between States are Animated automatically.
   };
 }