Index: code/branches/tutoriallevel2/doc/api/groups/Triggers.dox
===================================================================
--- code/branches/tutoriallevel2/doc/api/groups/Triggers.dox	(revision 8446)
+++ code/branches/tutoriallevel2/doc/api/groups/Triggers.dox	(revision 8447)
@@ -55,5 +55,5 @@
     - @b target Which specifies the class of objects that can trigger the @ref orxonox::DistanceTrigger "DistanceTrigger". Default is <code>"Pawn"</code>.
     - @b beaconMode Which specifies, whether the @ref orxonox::DistanceTrigger "DistanceTrigger" operates on @ref orxonox::DistanceTriggerBeacon "DistanceTriggerBeacons" or not. If <em>off</em> the DistanceMultiTrigger works as usual. If set to <em>identify</em> the @ref orxonox::DistanceTrigger "DistanceTrigger" is only triggered by objects that have a @ref orxonox::DistanceTriggerBeacon "DistanceTriggerBeacon", with the same name as specified in <em>targetname</em>, attached to them. If set to <em>exclude</em> the @ref orxonox::DistanceTrigger "DistanceTrigger" is only triggered by objects that don't have a @ref orxonox::DistanceTriggerBeacon "DistanceTriggerBeacon", with the same name as specified in <em>targetname</em>, attached to them. Default is <em>off</em>.
-    - @b targetname Which specifies the name @ref oroxnox::DistanceTriggerBeacon "DistanceTriggerBeacons" need to have to make the @ref orxonox::DistanceTrigger "DistanceTrigger" react to them if it is in <em>beacon-mode</em> (the beaconMode is not <em>off</em>).
+    - @b targetname Which specifies the name @ref orxonox::DistanceTriggerBeacon "DistanceTriggerBeacons" need to have to make the @ref orxonox::DistanceTrigger "DistanceTrigger" react to them if it is in <em>beacon-mode</em> (the beaconMode is not <em>off</em>).
 
     A simple @ref orxonox::DistanceTrigger "DistanceTrigger" could look like this:
Index: code/branches/tutoriallevel2/src/libraries/network/synchronisable/Synchronisable.cc
===================================================================
--- code/branches/tutoriallevel2/src/libraries/network/synchronisable/Synchronisable.cc	(revision 8446)
+++ code/branches/tutoriallevel2/src/libraries/network/synchronisable/Synchronisable.cc	(revision 8447)
@@ -383,5 +383,4 @@
   /**
    * This function determines, wheter the object should be saved to the bytestream (according to its syncmode/direction)
-   * @param id gamestate id
    * @param mode Synchronisation mode (toclient, toserver or bidirectional)
    * @return true/false
@@ -397,5 +396,4 @@
   /**
    * This function determines, wheter the object should accept data from the bytestream (according to its syncmode/direction)
-   * @param id gamestate id
    * @param mode Synchronisation mode (toclient, toserver or bidirectional)
    * @return true/false
Index: code/branches/tutoriallevel2/src/modules/objects/triggers/DistanceTrigger.cc
===================================================================
--- code/branches/tutoriallevel2/src/modules/objects/triggers/DistanceTrigger.cc	(revision 8446)
+++ code/branches/tutoriallevel2/src/modules/objects/triggers/DistanceTrigger.cc	(revision 8447)
@@ -280,5 +280,7 @@
         Check whether the DistanceTrigger is triggered.
         It is triggered if it is triggered according only to its mode (i.e. its sub-triggers) and if a target is in range.
-    @param
+    @param mode
+        The mode for which it is tested, whether the DistanceTrigger is triggered.
+    @return
         Returns true if it is triggered ,false if not.
     */
Index: code/branches/tutoriallevel2/src/modules/objects/triggers/DistanceTrigger.h
===================================================================
--- code/branches/tutoriallevel2/src/modules/objects/triggers/DistanceTrigger.h	(revision 8446)
+++ code/branches/tutoriallevel2/src/modules/objects/triggers/DistanceTrigger.h	(revision 8447)
@@ -71,5 +71,5 @@
         - @b target Which specifies the class of objects that can trigger the DistanceTrigger. Default is <code>"Pawn"</code>.
         - @b beaconMode Which specifies, whether the DistanceTrigger operates on @ref orxonox::DistanceTriggerBeacon "DistanceTriggerBeacons" or not. If <em>off</em> the DistanceMultiTrigger works as usual. If set to <em>identify</em> the DistanceTrigger is only triggered by objects that have a @ref orxonox::DistanceTriggerBeacon "DistanceTriggerBeacon", with the same name as specified in <em>targetname</em>, attached to them. If set to <em>exclude</em> the DistanceTrigger is only triggered by objects that don't have a @ref orxonox::DistanceTriggerBeacon "DistanceTriggerBeacon", with the same name as specified in <em>targetname</em>, attached to them. Default is <em>off</em>.
-        - @b targetname Which specifies the name @ref oroxnox::DistanceTriggerBeacon "DistanceTriggerBeacons" need to have to make the DistanceTrigger react to them if it is in <em>beacon-mode</em> (the beaconMode is not <em>off</em>).
+        - @b targetname Which specifies the name @ref orxonox::DistanceTriggerBeacon "DistanceTriggerBeacons" need to have to make the DistanceTrigger react to them if it is in <em>beacon-mode</em> (the beaconMode is not <em>off</em>).
 
         A simple DistanceTrigger could look like this:
Index: code/branches/tutoriallevel2/src/modules/objects/triggers/EventTrigger.h
===================================================================
--- code/branches/tutoriallevel2/src/modules/objects/triggers/EventTrigger.h	(revision 8446)
+++ code/branches/tutoriallevel2/src/modules/objects/triggers/EventTrigger.h	(revision 8447)
@@ -60,5 +60,5 @@
 
     @see Trigger
-        For more information on @ref oroxnox::Trigger "Triggers".
+        For more information on @ref orxonox::Trigger "Triggers".
 
     @author
Index: code/branches/tutoriallevel2/src/modules/questsystem/QuestManager.cc
===================================================================
--- code/branches/tutoriallevel2/src/modules/questsystem/QuestManager.cc	(revision 8446)
+++ code/branches/tutoriallevel2/src/modules/questsystem/QuestManager.cc	(revision 8447)
@@ -318,5 +318,6 @@
     @param player
         The player.
-    @return Returns the number of QuestHints of the input Quest for the input player.
+    @return
+        Returns the number of QuestHints of the input Quest for the input player.
     */
     int QuestManager::getNumHints(Quest* quest, PlayerInfo* player)
@@ -341,4 +342,6 @@
     @param index
         The index of the QuestHint.
+    @return
+        Returns a pointer to the index-th QuestHint of the input Quest for the input player.
     */
     QuestHint* QuestManager::getHints(Quest* quest, PlayerInfo* player, int index)
@@ -355,9 +358,9 @@
     /**
     @brief
-        Get the parent-quest of the input Quest for the input player.
+        Get the parent-quest of the input Quest.
     @param quest
         The Quest to get the parent-quest of.
-    @param player
-        The player.
+    @return
+        Returns a pointer to the parent-quest of the input Quest.
     */
     Quest* QuestManager::getParentQuest(Quest* quest)