Index: /branches/atmospheric_engine/src/lib/graphics/effects/cloud_effect.cc
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/cloud_effect.cc	(revision 8454)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/cloud_effect.cc	(revision 8455)
@@ -65,5 +65,5 @@
 
 
-bool CloudEffect::init()
+void CloudEffect::init()
 {
 	PRINTF(1)("Initializing CloudEffect\n");
@@ -84,5 +84,5 @@
 	float bbox[3] = {0};
 	cloudModel.GetDimensions(bbox[0], bbox[1], bbox[2]);
-	
+
 	// Load Shaders
 	this->cloudShader = new Shader( ResourceManager::getInstance()->getDataDir() + "/shaders/sky.vert", ResourceManager::getInstance()->getDataDir() +"/shaders/sky.frag");
@@ -115,5 +115,5 @@
 
 
-bool CloudEffect::activate()
+void CloudEffect::activate()
 {
 	PRINTF(0)( "Activating CloudEffect with Material %s\n", this->cloudTexture.c_str());
@@ -122,5 +122,5 @@
 }
 
-bool CloudEffect::deactivate()
+void CloudEffect::deactivate()
 {
 	PRINTF(0)("Deactivating CloudEffect\n");
@@ -133,5 +133,5 @@
 	if (!this->cloudActivate)
 		return;
-		
+
 	// 	glMatrixMode(GL_MODELVIEW);
 	// 	glPushMatrix();
@@ -159,5 +159,5 @@
 	// glCullFace(GL_BACK);
 	// glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
-	
+
 	// glLineWidth(3.0f);
 
@@ -209,5 +209,5 @@
 
 	glPopMatrix();
-	
+
 }
 
Index: /branches/atmospheric_engine/src/lib/graphics/effects/cloud_effect.h
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/cloud_effect.h	(revision 8454)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/cloud_effect.h	(revision 8455)
@@ -28,8 +28,8 @@
 		virtual void loadParams(const TiXmlElement* root);
 
-		virtual bool init();
+		virtual void init();
 
-		virtual bool activate();
-		virtual bool deactivate();
+		virtual void activate();
+		virtual void deactivate();
 
 		inline void activateCloud() { this->activate(); }
Index: /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc	(revision 8454)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc	(revision 8455)
@@ -71,23 +71,27 @@
 }
 
-bool FogEffect::init()
-{
-	//default values
-	this->fogActivate = false;
+void FogEffect::init()
+{
+	// default values
+	this->fogMode = GL_LINEAR;
+	this->fogDensity = 0.03;
+	this->fogStart = 0;
+	this->fogEnd = 50;
+	this->colorVector = Vector(0.3, 0.3, 0.3);
+
+	// init variables
 	this->fogFadeInDuration = 0;
 	this->fogFadeOutDuration = 0;
+	this->fogFadeInDensity = 0;
+	this->fogFadeOutDensity = 0;
 	this->localTimer = 0;
-	
-	this->fogMode = GL_LINEAR;
-	this->fogDensity = 0.05;
-	this->fogStart = 0;
-	this->fogEnd = 500;
-	this->colorVector = Vector(0.3, 0.3, 0.3);
-
-	return 0;
-}
-
-
-bool FogEffect::activate()
+	this->fogActivate = false;
+	this->fogFadeInActivate = false;
+	this->fogFadeOutActivate = false;
+
+}
+
+
+void FogEffect::activate()
 {
 	PRINTF(0)( "Enabling FogEffect, mode: %i, density: %f, start: %f, end: %f, color %f, %f, %f\n", this->fogMode, this->fogDensity, this->fogStart, this->fogEnd, this->colorVector.x, this->colorVector.y, this->colorVector.z);
@@ -102,13 +106,17 @@
 	glFogf(GL_FOG_END, this->fogEnd);
 
-	// glFogf(GL_FOG_DENSITY, this->fogDensity);
-
+	if ( this->fogFadeInActivate )
+		glFogf(GL_FOG_DENSITY, this->fogFadeInDensity);
+	else if ( this->fogFadeOutActivate )
+		glFogf(GL_FOG_DENSITY, this->fogFadeOutDensity);
+	else
+		glFogf(GL_FOG_DENSITY, this->fogDensity);
+		
 	glEnable(GL_FOG);
 
-	return 0;
-}
-
-
-bool FogEffect::deactivate()
+}
+
+
+void FogEffect::deactivate()
 {
 	PRINTF(0)("Deactivating FogEffect\n");
@@ -120,21 +128,18 @@
 	glDisable(GL_FOG);
 
-	return 0;
 }
 
 void FogEffect::draw() const {
 
+	if (!this->fogActivate)
+		return;
+
 	// If Fog Fade In
-	if ( this->fogFadeInActivate ) {
+	if ( this->fogFadeInActivate )
 		glFogf(GL_FOG_DENSITY, this->fogFadeInDensity);
-		// PRINTF(0)( "this->fogFadeInDensity: %f\n", this->fogFadeInDensity);
-	}
+
 	// If Fog Fade Out
-	else if ( this->fogFadeOutActivate )
+	if ( this->fogFadeOutActivate )
 		glFogf(GL_FOG_DENSITY, this->fogFadeOutDensity);
-
-	// Normal Fog activate
-	else
-		glFogf(GL_FOG_DENSITY, this->fogDensity);
 
 }
@@ -147,14 +152,13 @@
 	if ( this->fogFadeInActivate ) {
 		this->localTimer += dt;
-		float progress = this->localTimer / this->fogFadeInDuration;
-		this->fogFadeInDensity = progress * this->fogDensity;
+		this->fogFadeInDensity = ( this->localTimer / this->fogFadeInDuration ) * this->fogDensity;
 
 		if ( this->localTimer >= this->fogFadeOutDuration )
 			this->fogFadeInActivate = false;
 	}
-	else if ( this->fogFadeOutActivate ) {
+
+	if ( this->fogFadeOutActivate ) {
 		this->localTimer += dt;
-		float progress = this->localTimer / this->fogFadeInDuration;
-		this->fogFadeOutDensity = 1 - progress * this->fogDensity;
+		this->fogFadeOutDensity = 1 - (( this->localTimer / this->fogFadeInDuration ) * this->fogDensity);
 
 		if ( this->localTimer >= this->fogFadeOutDuration )
Index: /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.h
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.h	(revision 8454)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.h	(revision 8455)
@@ -18,8 +18,8 @@
 		virtual void loadParams(const TiXmlElement* root);
 
-		virtual bool init();
+		virtual void init();
 
-		virtual bool activate();
-		virtual bool deactivate();
+		virtual void activate();
+		virtual void deactivate();
 
 		void activateFog() { this->activate(); }
Index: /branches/atmospheric_engine/src/lib/graphics/effects/lightening_effect.cc
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/lightening_effect.cc	(revision 8454)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/lightening_effect.cc	(revision 8455)
@@ -38,5 +38,5 @@
 {
 	this->setClassID(CL_LIGHTENING_EFFECT, "LighteningEffect");
-  
+
 	this->init();
 
@@ -72,9 +72,9 @@
 
 
-bool LighteningEffect::init()
+void LighteningEffect::init()
 {
 	//default values
 	this->lighteningActivate = false;
-	
+
 	this->time = 0.0;
 	this->flashFrequency = 4.0f;
@@ -82,5 +82,5 @@
 	this->flashConstTime = 0.1f;
 	this->flashRisingTime = 0.03f;
-	
+
 	this->width = 700.0f;
 	this->height = 250.0f;
@@ -89,13 +89,13 @@
 	this->bNewCoordinate = false;
   this->lighteningMove = false;
-	
+
 	this->seedX = 500.f;
 	this->seedZ = 1000.0f;
 	this->seedTime = 2.0f;
-  
+
   this->mainPosX = 3000;
   this->mainPosY = 900;
   this->mainPosZ = 0;
-	
+
 	// initialize lightening textures
 	this->billboard[0] = new Billboard(NULL);
@@ -103,20 +103,20 @@
 	this->billboard[0]->setSize(this->width, this->height);
 	this->billboard[0]->setVisibiliy(false);
-	
+
 	this->billboard[1] = new Billboard(NULL);
 	this->billboard[1]->setTexture("maps/lightning_bolt2.png");
 	this->billboard[1]->setSize(this->width, this->height);
 	this->billboard[1]->setVisibiliy(false);
-	
+
 	this->billboard[2] = new Billboard(NULL);
 	this->billboard[2]->setTexture("maps/lightning_bolt3.png");
 	this->billboard[2]->setSize(this->width, this->height);
 	this->billboard[2]->setVisibiliy(false);
-	
+
 	this->billboard[3] = new Billboard(NULL);
 	this->billboard[3]->setTexture("maps/lightning_bolt4.png");
 	this->billboard[3]->setSize(this->width, this->height);
 	this->billboard[3]->setVisibiliy(false);
-	
+
 	if (this->lighteningMove) {
 		this->cameraCoor = State::getCameraNode()->getAbsCoor();
@@ -131,15 +131,15 @@
 		this->billboard[3]->setAbsCoor(3000,900,0);
 	}
-	
+
 	this->flashLight = new Light();
 	this->flashLight->setDiffuseColor(0,0,0);
 	this->flashLight->setSpecularColor(0,0,0);
-	
+
 	/*
 	this->soundSource = NULL;
 	this->thunderBuffer = NULL;
-	
+
 	this->soundSource.setSourceNode(this);
-	
+
 	//load sound
 	if (this->thunderBuffer != NULL)
@@ -147,5 +147,4 @@
 	this->thunderBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load("sound/thunder.wav", WAV);*/
 
-	return 0;
 }
 
@@ -185,5 +184,5 @@
 
 
-bool LighteningEffect::activate()
+void LighteningEffect::activate()
 {
 	PRINTF(0)( "Activating LighteningEffect\n" );
@@ -191,10 +190,8 @@
 
 	this->time = 0;
-
-	return 0;
-}
-
-
-bool LighteningEffect::deactivate()
+}
+
+
+void LighteningEffect::deactivate()
 {
 	PRINTF(0)("Deactivating LighteningEffect\n");
@@ -205,6 +202,4 @@
 	this->billboard[2]->setVisibiliy(false);
 	this->billboard[3]->setVisibiliy(false);
-
-	return 0;
 }
 
@@ -213,14 +208,14 @@
 	if(!lighteningActivate)
 		return;
-	
+
 	this->time += dt;
 
 	// TODO: Make random flashing with short light dingsda:)
-	
+
 	if( this->time > this->flashFrequency) {
-	
+
 		this->billboard[0]->setVisibiliy(true);
 		this->time = 0.0f;
-	
+
 		this->flashLight->setAbsCoor(this->billboard[0]->getAbsCoor().x, this->billboard[0]->getAbsCoor().y, this->billboard[0]->getAbsCoor().z);
 
@@ -228,9 +223,9 @@
 		this->flashLight->setDiffuseColor(1,1,1);
 		this->flashLight->setSpecularColor(1,1,1);
-	
+
 		//this->soundSource.play(this->thunderBuffer);
 
 	} else if( this->billboard[3]->isVisible() && this->time > this->flashConstTime) {
-	
+
 		this->billboard[3]->setVisibiliy(false);
 		this->time = 0.0f;
@@ -240,33 +235,33 @@
 
 	}
-	
+
 	if( this->billboard[2]->isVisible() && this->time > this->flashRisingTime) {
-	
+
 		this->billboard[2]->setVisibiliy(false);
 		this->billboard[3]->setVisibiliy(true);
 		// this->flashLight->setDiffuseColor(1,1,1);
 		// this->flashLight->setSpecularColor(1,1,1);
-		
+
 	} else if( this->billboard[1]->isVisible() && this->time > this->flashRisingTime*2/3 ) {
-	
+
 		this->billboard[1]->setVisibiliy(false);
 		this->billboard[2]->setVisibiliy(true);
 		//this->flashLight->setDiffuseColor(0,0,0);
 		//this->flashLight->setSpecularColor(0,0,0);
-		
+
 	} else if( this->billboard[0]->isVisible() && this->time > this->flashRisingTime*1/3 ) {
-	
+
 		this->billboard[0]->setVisibiliy(false);
 		this->billboard[1]->setVisibiliy(true);
 		//this->flashLight->setDiffuseColor(1,1,1);
 		//this->flashLight->setSpecularColor(1,1,1);
-		
-	}
-	
+
+	}
+
 	if( this->bNewCoordinate) {
 		float posX, posZ;
 
 		if(this->lighteningMove) {
-		
+
 			this->cameraCoor = State::getCameraNode()->getAbsCoor();
 			posX = this->mainPosX - this->seedX * (float)rand()/(float)RAND_MAX + this->cameraCoor.x;
@@ -274,25 +269,25 @@
 
 		} else {
-		
+
 			posX = this->mainPosX - this->seedX * (float)rand()/(float)RAND_MAX;
 			posZ = this->mainPosZ + this->seedZ * (float)rand()/(float)RAND_MAX;
 
 		}
-	
+
 		this->billboard[0]->setAbsCoor(posX, this->mainPosY, posZ);
 		this->billboard[1]->setAbsCoor(posX, this->mainPosY, posZ);
 		this->billboard[2]->setAbsCoor(posX, this->mainPosY, posZ);
 		this->billboard[3]->setAbsCoor(posX, this->mainPosY, posZ);
-		
+
 		this->flashFrequency = this->mainFrequency + this->seedTime * (float)rand()/(float)RAND_MAX;
-		
+
 		float w = this->width + this->seedWidth * (float)rand()/(float)RAND_MAX;
 		float h = this->height + this->seedHeight * (float)rand()/(float)RAND_MAX;
-		
+
 		this->billboard[0]->setSize(w, h);
 		this->billboard[1]->setSize(w, h);
 		this->billboard[2]->setSize(w, h);
 		this->billboard[3]->setSize(w, h);
-		
+
 		this->bNewCoordinate = false;
 	}
Index: /branches/atmospheric_engine/src/lib/graphics/effects/lightening_effect.h
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/lightening_effect.h	(revision 8454)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/lightening_effect.h	(revision 8455)
@@ -25,11 +25,11 @@
 		virtual void loadParams(const TiXmlElement* root);
 
-		virtual bool init();
+		virtual void init();
 
-		virtual bool activate();
-		virtual bool deactivate();
+		virtual void activate();
+		virtual void deactivate();
 
-		inline void activateLightening() { this->activate(); }
-		inline void deactivateLightening() { this->deactivate(); }
+		inline  void activateLightening() { this->activate(); }
+		inline  void deactivateLightening() { this->deactivate(); }
 
 		virtual void draw() const;
Index: /branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.cc
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.cc	(revision 8454)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.cc	(revision 8455)
@@ -105,5 +105,5 @@
 
 
-bool RainEffect::init()
+void RainEffect::init()
 {
 	//Default values
@@ -126,6 +126,4 @@
 	lightMan = LightManager::getInstance();
 	this->rainAmbient = lightMan->getAmbientColor();
-
-	return 0;
 }
 
@@ -133,5 +131,5 @@
 SparkParticles* RainEffect::rainParticles = NULL;
 
-bool RainEffect::activate()
+void RainEffect::activate()
 {
 	PRINTF(0)( "Activating RainEffect, coord: %f, %f, %f, size: %f, %f, rate: %f, velocity: %f, moveRain: %s\n", this->rainCoord.x, this->rainCoord.y, this->rainCoord.z, this->rainSize.x, this-> rainSize.y, this->rainRate, this->rainVelocity, this->rainMove ? "true" : "false" );
@@ -168,9 +166,8 @@
 		lightMan->setAmbientColor(.1,.1,.1);
 
-	return 0;
-}
-
-
-bool RainEffect::deactivate()
+}
+
+
+void RainEffect::deactivate()
 {
 	PRINTF(0)("Deactivating RainEffect\n");
@@ -185,5 +182,4 @@
 	lightMan->setAmbientColor(this->rainAmbient, this->rainAmbient, this->rainAmbient);
 
-	return 0;
 }
 
Index: /branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.h
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.h	(revision 8454)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.h	(revision 8455)
@@ -30,8 +30,8 @@
 		virtual void loadParams(const TiXmlElement* root);
 
-		virtual bool init();
+		virtual void init();
 
-		virtual bool activate();
-		virtual bool deactivate();
+		virtual void activate();
+		virtual void deactivate();
 
 		inline void activateRain() { this->activate(); }
Index: /branches/atmospheric_engine/src/lib/graphics/effects/snow_effect.cc
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/snow_effect.cc	(revision 8454)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/snow_effect.cc	(revision 8455)
@@ -79,5 +79,5 @@
 	LoadParam(root, "size", this, SnowEffect, size);
 	LoadParam(root, "coord", this, SnowEffect, coord);
-  
+
 	LOAD_PARAM_START_CYCLE(root, element);
 	{
@@ -87,5 +87,5 @@
 }
 
-bool SnowEffect::init()
+void SnowEffect::init()
 {
 	this->emitter = new PlaneEmitter();
@@ -113,5 +113,5 @@
 }
 
-bool SnowEffect::activate()
+void SnowEffect::activate()
 {
 	PRINTF(0)("Activating SnowEffect\n");
@@ -146,5 +146,5 @@
 
 
-bool SnowEffect::deactivate()
+void SnowEffect::deactivate()
 {
 	PRINTF(0)("Deactivating SnowEffect\n");
@@ -171,5 +171,5 @@
 	/*
 	float distance = (State::getCameraNode()->getAbsCoor() - Vector(snowCoord.x, State::getCameraNode()->getAbsCoor().y, snowCoord.z)).len();
-	
+
 	if(activated)
 	{
@@ -182,5 +182,5 @@
 	else if(distance > 0.1*snowSize.x || distance > 0.1*snowSize.y)
 	this->alpha = 0.4;
-	
+
 	SnowEffect::snowParticles->setColor(0,1, 1, 1, alpha);
 	SnowEffect::snowParticles->setColor(.5, .6, .6, .6, alpha/2);
@@ -197,5 +197,5 @@
 	else if( distance < 0.1*snowSize.x || distance < 0.1*snowSize.y )
 	this->alpha = 0.5;
-	
+
 	SnowEffect::snowParticles->setColor(0,1, 1, 1, alpha);
 	SnowEffect::snowParticles->setColor(.5, .6, .6, .6, alpha/2);
Index: /branches/atmospheric_engine/src/lib/graphics/effects/snow_effect.h
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/snow_effect.h	(revision 8454)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/snow_effect.h	(revision 8455)
@@ -28,8 +28,8 @@
 		virtual void loadParams(const TiXmlElement* root);
 
-		virtual bool init();
+		virtual void init();
 
-		virtual bool activate();
-		virtual bool deactivate();
+		virtual void activate();
+		virtual void deactivate();
 
 		inline void activateSnow() { this->activate(); }
Index: /branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.cc
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.cc	(revision 8454)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.cc	(revision 8455)
@@ -29,5 +29,5 @@
 
 //#include <GL/glext.h> //OpenGL Extensions
-//#include <GL/glxext.h> // GLX Extensions 
+//#include <GL/glxext.h> // GLX Extensions
 
 #ifndef GL_EXT_fog_coord
@@ -76,5 +76,5 @@
 }
 
-bool VolFogEffect::init()
+void VolFogEffect::init()
 {
 	PRINTF(0)("Initalize VolFogEffect\n");
@@ -92,5 +92,5 @@
 	// Set fog color
 	float fogColor[4] = {0.6f,0.58f,0.79f,0.0f};
-	
+
 
 	glFogCoordfEXT       = (PFNGLFOGCOORDFEXTPROC)glXGetProcAddressARB((const GLubyte*)"glFogCoordfEXT");
@@ -117,22 +117,14 @@
 
 	if (glewGetExtension("GL_EXT_fog_coord"))
-	{
 		PRINTF(0)("GL_EXT_fog_coord extension found\n");
-		return true;
-	}
-	else
-	{
-		PRINTF(0)("GL_EXT_fog_coord extension NOT found\n");
-		return false;
-	}
-}
-
-
-bool VolFogEffect::activate()
+}
+
+
+void VolFogEffect::activate()
 {
 	PRINTF(0)("Activating VolFogEffect\n");
 }
 
-bool VolFogEffect::deactivate()
+void VolFogEffect::deactivate()
 {
 	PRINTF(0)("Deactivating VolFogEffect\n");
@@ -160,9 +152,9 @@
 	//glEnable(GL_BLEND);
 	//glBlendFunc(GL_SRC_ALPHA, GL_DST_ALPHA);
-	
+
 	int i;
 	glLoadIdentity();
 
-	
+
 	glBegin( GL_LINES );
 		glNormal3f(0,1,0);
@@ -210,5 +202,5 @@
 * ticks the effect if there is any time dependancy
 */
-void VolFogEffect::tick(float dt)	
-{
-}
+void VolFogEffect::tick(float dt)
+{
+}
Index: /branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.h
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.h	(revision 8454)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/volfog_effect.h	(revision 8455)
@@ -18,8 +18,8 @@
 		virtual void loadParams(const TiXmlElement* root);
 
-		virtual bool init();
+		virtual void init();
 
-		virtual bool activate();
-		virtual bool deactivate();
+		virtual void activate();
+		virtual void deactivate();
 
 		virtual void draw() const;
Index: /branches/atmospheric_engine/src/lib/graphics/effects/weather_effect.cc
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/weather_effect.cc	(revision 8454)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/weather_effect.cc	(revision 8455)
@@ -55,5 +55,5 @@
  *  initializes the graphics effect
  */
-bool WeatherEffect::init()
+void WeatherEffect::init()
 {}
 
Index: /branches/atmospheric_engine/src/lib/graphics/effects/weather_effect.h
===================================================================
--- /branches/atmospheric_engine/src/lib/graphics/effects/weather_effect.h	(revision 8454)
+++ /branches/atmospheric_engine/src/lib/graphics/effects/weather_effect.h	(revision 8455)
@@ -18,13 +18,13 @@
     virtual void loadParams(const TiXmlElement* root);
 
-    virtual bool init();
+    virtual void init();
 
-    virtual bool activate() = 0;
-    virtual bool deactivate() = 0;
+    virtual void activate();
+    virtual void deactivate();
 
     virtual void draw() const;
     virtual void tick(float dt);
 
-    inline bool isActivated() const { return this->bActivated; }
+    inline  bool isActivated() const { return this->bActivated; }
 
 